package ch.epfl.ppo;

public final class Complex {
    private final double re, im;

    public static final Complex ZERO = new Complex(0, 0);

    public Complex(double re, double im) {
        this.re = re;
        this.im = im;
    }

    public Complex add(Complex that) {
        return new Complex(re + that.re, im + that.im);
    }

    public Complex squared() {
        return new Complex(re * re - im * im, 2d * re * im);
    }

    public double modulusSquared() {
        return re * re + im * im;
    }
}
