package ch.epfl.ppo.gui;

import static javax.swing.SwingUtilities.invokeLater;

import java.awt.BorderLayout;

import javax.swing.JFrame;
import javax.swing.Timer;

import ch.epfl.ppo.Animation;
import ch.epfl.ppo.ColorRGB;
import ch.epfl.ppo.Image;


public final class AnimationViewer {
    public static void main(String[] args) {
        invokeLater(() -> {
            // L'animation à afficher, à modifier au fur et à mesure de
            // votre avancement.
            Image<ColorRGB> mandelbrot = Image.ofBooleanImage(Image.mandelbrotSet(100), ColorRGB.RED, ColorRGB.BLACK);
            Animation<ColorRGB> animation = Animation.constant(mandelbrot);

            JFrame mainWindow = new JFrame("Animation viewer");
            mainWindow.setDefaultCloseOperation(JFrame.EXIT_ON_CLOSE);

            mainWindow.getContentPane().setLayout(new BorderLayout());
            ImageComponent imageComponent = new ImageComponent(animation.imageAt(0), 0, 0, 4);
            mainWindow.getContentPane().add(imageComponent, BorderLayout.CENTER);

            mainWindow.pack();
            mainWindow.setVisible(true);

            long startingTime = System.nanoTime();
            new Timer(1000 / 30, e -> {
                long deltaNs = System.nanoTime() - startingTime;
                imageComponent.setImage(animation.imageAt(deltaNs / 1e9));
            }).start();
        });
    }
}
